# CbcTreeLocal Class Reference

`#include <CbcTreeLocal.hpp>`

Inheritance diagram for CbcTreeLocal:
[legend]
Collaboration diagram for CbcTreeLocal:
[legend]

List of all members.

## Public Member Functions
| CbcTreeLocal ()
| CbcTreeLocal (CbcModel *model, const double *solution, int range=10, int typeCuts=0, int maxDiversification=0, int timeLimit=1000000, int nodeLimit=1000000, bool refine=true)
| CbcTreeLocal (const CbcTreeLocal &rhs)
CbcTreeLocal & | operator= (const CbcTreeLocal &rhs)
| = operator
virtual | ~CbcTreeLocal ()
virtual CbcTree * | clone () const
| Clone.
virtual void | generateCpp (FILE *fp)
| Create C++ lines to get to current state.
Heap access and maintenance methods
virtual CbcNode * | top () const
| Return the top node of the heap.
virtual void | push (CbcNode *x)
| Add a node to the heap.
virtual void | pop ()
| Remove the top node from the heap.
Other stuff
int | createCut (const double *solution, OsiRowCut &cut)
| Create cut - return -1 if bad, 0 if okay and 1 if cut is everything.
virtual bool | empty ()
| Test if empty *** note may be overridden.
virtual void | endSearch ()
| We may have got an intelligent tree so give it one more chance.
void | reverseCut (int state, double bias=0.0)
| Other side of last cut branch (if bias==rhs_ will be weakest possible).
void | deleteCut (OsiRowCut &cut)
| Delete last cut branch.
void | passInSolution (const double *solution, double solutionValue)
| Pass in solution (so can be used after heuristic).
int | range () const
void | setRange (int value)
int | typeCuts () const
void | setTypeCuts (int value)
int | maxDiversification () const
void | setMaxDiversification (int value)
int | timeLimit () const
void | setTimeLimit (int value)
int | nodeLimit () const
void | setNodeLimit (int value)
bool | refine () const
void | setRefine (bool yesNo)
## Private Attributes
CbcNode * | localNode_
double * | bestSolution_
double * | savedSolution_
int | saveNumberSolutions_
OsiRowCut | cut_
OsiRowCut | fixedCut_
CbcModel * | model_
double * | originalLower_
double * | originalUpper_
int | range_
int | typeCuts_
int | maxDiversification_
int | diversification_
bool | nextStrong_
double | rhs_
double | savedGap_
double | bestCutoff_
int | timeLimit_
int | startTime_
int | nodeLimit_
int | startNode_
int | searchType_
bool | refine_

## Detailed Description

Definition at line 40 of file CbcTreeLocal.hpp.

## Constructor & Destructor Documentation

CbcTreeLocal::CbcTreeLocal | ( |  | ) |

CbcTreeLocal::CbcTreeLocal | ( | CbcModel * | model,
|  | const double * | solution,
|  | int | range = `10`,
|  | int | typeCuts = `0`,
|  | int | maxDiversification = `0`,
|  | int | timeLimit = `1000000`,
|  | int | nodeLimit = `1000000`,
|  | bool | refine = `true` |
| ) |  |  |

CbcTreeLocal::CbcTreeLocal | ( | const CbcTreeLocal & | rhs | ) |

virtual CbcTreeLocal::~CbcTreeLocal | ( |  | ) | `[virtual]`

## Member Function Documentation

CbcTreeLocal& CbcTreeLocal::operator= | ( | const CbcTreeLocal & | rhs | ) |

= operator

Reimplemented from CbcTree.

virtual CbcTree* CbcTreeLocal::clone | ( |  | ) | const`[virtual]`

Clone.

Reimplemented from CbcTree.

virtual void CbcTreeLocal::generateCpp | ( | FILE * | fp | ) | `[virtual]`

Create C++ lines to get to current state.

Reimplemented from CbcTree.

virtual CbcNode* CbcTreeLocal::top | ( |  | ) | const`[virtual]`

Return the top node of the heap.

Reimplemented from CbcTree.

virtual void CbcTreeLocal::push | ( | CbcNode * | x | ) | `[virtual]`

Add a node to the heap.

Reimplemented from CbcTree.

virtual void CbcTreeLocal::pop | ( |  | ) | `[virtual]`

Remove the top node from the heap.

Reimplemented from CbcTree.

int CbcTreeLocal::createCut | ( | const double * | solution,
|  | OsiRowCut & | cut |
| ) |  |  |

Create cut - return -1 if bad, 0 if okay and 1 if cut is everything.

virtual bool CbcTreeLocal::empty | ( |  | ) | `[virtual]`

Test if empty *** note may be overridden.

Reimplemented from CbcTree.

virtual void CbcTreeLocal::endSearch | ( |  | ) | `[virtual]`

We may have got an intelligent tree so give it one more chance.

Reimplemented from CbcTree.

void CbcTreeLocal::reverseCut | ( | int | state,
|  | double | bias = `0.0` |
| ) |  |  |

Other side of last cut branch (if bias==rhs_ will be weakest possible).

void CbcTreeLocal::deleteCut | ( | OsiRowCut & | cut | ) |

Delete last cut branch.

void CbcTreeLocal::passInSolution | ( | const double * | solution,
|  | double | solutionValue |
| ) |  |  |

Pass in solution (so can be used after heuristic).

int CbcTreeLocal::range | ( |  | ) | const`[inline]`

Definition at line 107 of file CbcTreeLocal.hpp.

void CbcTreeLocal::setRange | ( | int | value | ) | `[inline]`

Definition at line 111 of file CbcTreeLocal.hpp.

int CbcTreeLocal::typeCuts | ( |  | ) | const`[inline]`

Definition at line 115 of file CbcTreeLocal.hpp.

void CbcTreeLocal::setTypeCuts | ( | int | value | ) | `[inline]`

Definition at line 119 of file CbcTreeLocal.hpp.

int CbcTreeLocal::maxDiversification | ( |  | ) | const`[inline]`

Definition at line 123 of file CbcTreeLocal.hpp.

void CbcTreeLocal::setMaxDiversification | ( | int | value | ) | `[inline]`

Definition at line 127 of file CbcTreeLocal.hpp.

int CbcTreeLocal::timeLimit | ( |  | ) | const`[inline]`

Definition at line 131 of file CbcTreeLocal.hpp.

void CbcTreeLocal::setTimeLimit | ( | int | value | ) | `[inline]`

Definition at line 135 of file CbcTreeLocal.hpp.

int CbcTreeLocal::nodeLimit | ( |  | ) | const`[inline]`

Definition at line 139 of file CbcTreeLocal.hpp.

void CbcTreeLocal::setNodeLimit | ( | int | value | ) | `[inline]`

Definition at line 143 of file CbcTreeLocal.hpp.

bool CbcTreeLocal::refine | ( |  | ) | const`[inline]`

Definition at line 147 of file CbcTreeLocal.hpp.

void CbcTreeLocal::setRefine | ( | bool | yesNo | ) | `[inline]`

Definition at line 151 of file CbcTreeLocal.hpp.

## Member Data Documentation

CbcNode* CbcTreeLocal::localNode_`[private]`

Definition at line 158 of file CbcTreeLocal.hpp.

double* CbcTreeLocal::bestSolution_`[private]`

Definition at line 160 of file CbcTreeLocal.hpp.

double* CbcTreeLocal::savedSolution_`[private]`

Definition at line 162 of file CbcTreeLocal.hpp.

int CbcTreeLocal::saveNumberSolutions_`[private]`

Definition at line 164 of file CbcTreeLocal.hpp.

OsiRowCut CbcTreeLocal::cut_`[private]`

Definition at line 166 of file CbcTreeLocal.hpp.

OsiRowCut CbcTreeLocal::fixedCut_`[private]`

Definition at line 168 of file CbcTreeLocal.hpp.

CbcModel* CbcTreeLocal::model_`[private]`

Definition at line 170 of file CbcTreeLocal.hpp.

double* CbcTreeLocal::originalLower_`[private]`

Definition at line 172 of file CbcTreeLocal.hpp.

double* CbcTreeLocal::originalUpper_`[private]`

Definition at line 174 of file CbcTreeLocal.hpp.

int CbcTreeLocal::range_`[private]`

Definition at line 176 of file CbcTreeLocal.hpp.

int CbcTreeLocal::typeCuts_`[private]`

Definition at line 178 of file CbcTreeLocal.hpp.

int CbcTreeLocal::maxDiversification_`[private]`

Definition at line 180 of file CbcTreeLocal.hpp.

int CbcTreeLocal::diversification_`[private]`

Definition at line 182 of file CbcTreeLocal.hpp.

bool CbcTreeLocal::nextStrong_`[private]`

Definition at line 184 of file CbcTreeLocal.hpp.

double CbcTreeLocal::rhs_`[private]`

Definition at line 186 of file CbcTreeLocal.hpp.

double CbcTreeLocal::savedGap_`[private]`

Definition at line 188 of file CbcTreeLocal.hpp.

double CbcTreeLocal::bestCutoff_`[private]`

Definition at line 190 of file CbcTreeLocal.hpp.

int CbcTreeLocal::timeLimit_`[private]`

Definition at line 192 of file CbcTreeLocal.hpp.

int CbcTreeLocal::startTime_`[private]`

Definition at line 194 of file CbcTreeLocal.hpp.

int CbcTreeLocal::nodeLimit_`[private]`

Definition at line 196 of file CbcTreeLocal.hpp.

int CbcTreeLocal::startNode_`[private]`

Definition at line 198 of file CbcTreeLocal.hpp.

int CbcTreeLocal::searchType_`[private]`

Definition at line 200 of file CbcTreeLocal.hpp.

bool CbcTreeLocal::refine_`[private]`

Definition at line 202 of file CbcTreeLocal.hpp.

The documentation for this class was generated from the following file:

- /home/coin/svn-release/Cbc-2.8.1/Cbc/src/CbcTreeLocal.hpp

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Defines